<?php

/**
 * @package 	JST Snow
 * @author 		Valeriy Kosolapow https://jstart.ru
 * @copyright 	Copyright (c) 2022 JStart
 * @license 	http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 or later
 */

//No direct access
defined('_JEXEC') or die('Restricted Access');

use Joomla\CMS\Factory as JFactory;
use Joomla\CMS\Plugin\CMSPlugin;

class PlgSystemJST_Snow extends CMSPlugin
{
	/**
	 * Constructor
	 * @param   object  $subject
	 * @param   array   $config 
	 */
	public function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
	}

	public function onBeforeCompileHead()
	{
		$plg_name = 'jst_snow';
		$media_path = 'plg_' . $plg_name;

		$this->app = JFactory::getApplication();

		if ($this->app->isClient('site')) {
			if (version_compare(JVERSION, '4', 'gt')) {
				$wam = JFactory::getApplication()->getDocument()->getWebAssetManager();

				$wam->registerAndUseStyle($plg_name, 'media/' . $media_path . '/css/snow.min.css', ['version' => '1.0.0']);
				if ($wam->assetExists('style', $plg_name)) {
					$wam->useStyle($plg_name);
				}

				$wam->registerAndUseScript($plg_name . '_sparticles', 'media/' . $media_path . '/js/sparticles.min.js', ['version' => '1.0.0'], ['defer' => true]);
				if ($wam->assetExists('script', $plg_name)) {
					$wam->useScript($plg_name);
				}

				$wam->registerAndUseScript($plg_name . '_snow', 'media/' . $media_path . '/js/snow.min.js', ['version' => '1.0.0'], ['defer' => true]);
				if ($wam->assetExists('script', $plg_name)) {
					$wam->useScript($plg_name);
				}
			} else {
				$doc = JFactory::getDocument();

				$doc->addStyleSheet('/media/' . $media_path . '/css/snow.min.css');

				$doc->addScript('/media/' . $media_path . '/js/sparticles.min.js', $type = "text/javascript", $defer = true);
				$doc->addScript('/media/' . $media_path . '/js/snow.min.js', $type = "text/javascript", $defer = true);
			}
		}
	}
}
